# This is a basic workflow to help you get started with Actions

name: Merge Gate

# Controls when the action will run. 
on:
  # Triggers the workflow on push or pull request events but only for the master branch
  push:
    branches: [ master ]
  pull_request:
    branches: [ master ]

  # Allows you to run this workflow manually from the Actions tab
  workflow_dispatch:

# A workflow run is made up of one or more jobs that can run sequentially or in parallel
jobs:
  # This workflow contains a single job called "build"
  build:
    # The type of runner that the job will run on
    runs-on: ubuntu-latest

    strategy:
      matrix:
        os: [ubuntu-latest]
        python-version: [3.8.5]

    # Steps represent a sequence of tasks that will be executed as part of the job
    steps:
      # Checks-out your repository under $GITHUB_WORKSPACE, so your job can access it
      - uses: actions/checkout@v2
      - uses: Gr1N/setup-poetry@v4

      - name: Setup Python ${{ matrix.python-version }}
        uses: actions/setup-python@v2
        with:
            python-version: ${{ matrix.python-version }}
  
      - name: Print Python Version
        run: python -c "import sys; print(sys.version)"

      - name: Install Base Dependencies
        run: |
          python -m ensurepip
          python -m pip install virtualenv

      - name: PIP - Create, Activate and Setup the Virtual Environment
        run: |
          virtualenv .pipvenv
          source .pipvenv/bin/activate
          python3 $GITHUB_WORKSPACE/setup.py install
          deactivate

      - name: POETRY - Create, Activate and Setup the Virtual Environment
        run: poetry install

